
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Controller不是tableView的垃圾桶 / iVAN</title>

    <meta name="description" content="Controller不是tableView的垃圾桶 说在前面: 最近有个MVVM模式非常火热,相信它的出现是为了模块化iOS开发,其实在我看来,它始终还是MVC模式,只是一个变种罢了.(当然有人用到了响应式编程的思路颠覆了常规, 但我们今天把讨论点集中于代码的设计模式). 与其专注于说明 MVVM 的来历,不如让我们看一个典型的 iOS 是如何构建的,并从那里了解MVVM: Typical Model-View-Controller setup 我们看到的是一个典型的 MVC设置.Model呈现数据,View呈现用户界面,而 View Contr">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Controller不是tableView的垃圾桶</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>说在前面:</p>
<p>最近有个MVVM模式非常火热，相信它的出现是为了模块化iOS开发，其实在我看来,它始终还是MVC模式，只是一个变种罢了。(当然有人用到了响应式编程的思路颠覆了常规， 但我们今天把讨论点集中于代码的设计模式)。</p>
<p>与其专注于说明 MVVM 的来历，不如让我们看一个典型的 iOS 是如何构建的，并从那里了解MVVM：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2MuY29jaW1nLmNvbS9hcGkvdXBsb2Fkcy8yMDE1MTIxNS8xNDUwMTQ1OTg3MzQ2MjkyLnBuZw==.jpg"></p>
<p>Typical Model-View-Controller setup</p>
<p>我们看到的是一个典型的 MVC设置。Model呈现数据，View呈现用户界面，而 View Controller调节它两者之间的交互。</p>
<p>稍微考虑一下，虽然View 和 View Controller是技术上不同的组件，但它们几乎总是手牵手在一起，成对的。你什么时候看到一个 View能够与不同 View Controller配对？或者反过来？所以，为什么不正规化它们的连接呢？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2MuY29jaW1nLmNvbS9hcGkvdXBsb2Fkcy8yMDE1MTIxNS8xNDUwMTQ2MDE1MzYxMzkzLnBuZw==.jpg"></p>
<p>Intermediate</p>
<p>这更准确地描述了你可能已经编写的 MVC代码。但它并没有做太多事情来解决iOS应用中日益增长的重量级视图控制器。在典型的 MVC 应用里，许多逻辑被放在View Controller里。它们中的一些确实属于View Controller，但更多的是所谓的“用于显示的逻辑”，以 MVVM 属术语来说——就是那些从Model转换数据为 View可以呈现的东西的事情，例如将一个NSDate 转换为一个格式化过的 NSString。</p>
<p>我们的图解里缺少某些东西。某些使我们可以放置所有表示逻辑的东西。我们打算将其称为“View Model”——它位于 View/Controller与 Model之间：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2MuY29jaW1nLmNvbS9hcGkvdXBsb2Fkcy8yMDE1MTIxNS8xNDUwMTQ2MDMyNTc2OTgwLnBuZw==.jpg"></p>
<p>Model-View-ViewModel</p>
<p>看起好多了！这个图解准确地描述了什么是 MVVM：一个 MVC 的增强版，我们正式连接了视图和控制器，并将表示逻辑从 Controller 移出放到一个新的对象里，即 View Model。MVVM 听起来很复杂，但它本质上就是一个精心优化的 MVC架构，而 MVC你早已熟悉。</p>
<p>好了, 引言说完了, 这是一个铺垫 .</p>
<p>如果你认为下图右边的方法全部放在ViewController里便于日后维护和扩展的话 . 你大可固执己见然后点击浏览器右上角的"×" ...</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2MuY29jaW1nLmNvbS9hcGkvdXBsb2Fkcy8yMDE1MTIxNS8xNDUwMTQ2MDY2MjEyOTgyLnBuZw==.jpg"></p>
<p>屏幕快照 2015-12-14 下午3.58.00.png</p>
<p>当然, 关于瘦身ViewController有很多方面 . 然而今天我们讲讲从Controller中分离TableView的表示逻辑。为什么引言MVVM设计模式，也是阐述这个主要思想是相通的。 就是把"逻辑部分"尽量移到Model层, 你可以认为它是一个中间层，所谓"逻辑部分"可以是各种delegate,网络请求,缓存,数据库,coredata等等等等，而controller正是用来组织串联他们，使得整个程序走通。</p>
<p><strong>正文</strong></p>
<p>我们很容易想到把 UITableViewDataSource和UITableViewDelegate 的代码提取出来放到一个单独的类。</p>
<p>但我发现还是有东西可以抽象出来。</p>
<p>例如cell的生成、cell行高以及点击等等。这里我还用了block的形式使得函数能够回调。如果你对block还不太了解先<a href="http://www.jianshu.com/p/079219ba122b" rel="external nofollow noreferrer">看这里</a>。</p>
<p>此外，如果你也重度使用.xib生成Cell，那和我封装的类会非常契合。</p>
<p>记住我默认习惯用.xib前的文件名来定义cell的Identifier。如果你想把它用于实战，记得在xib设置cell的Identifier不要设错。</p>
<p>处理类XTTableDataDelegate的.h</p>
<table>
<tbody>
<tr>
<td>
<br />
1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17
</td>
<td>
<p><code>#import #import @class XTRootCustomCell ;</code></p>
<p> </p>
<p><code>typedef void    (^TableViewCellConfigureBlock)(NSIndexPath *indexPath, id item, XTRootCustomCell *cell) ;</code></p>
<p><code>typedef CGFloat (^CellHeightBlock)(NSIndexPath *indexPath, id item) ;</code></p>
<p><code>typedef void    (^DidSelectCellBlock)(NSIndexPath *indexPath, id item) ;</code></p>
<p> </p>
<p><code>@interface XTTableDataDelegate : NSObject </code><code>//1</code></p>
<p><code>- (id)initWithItems:(NSArray *)anItems</code></p>
<p><code>     </code><code>cellIdentifier:(NSString *)aCellIdentifier</code></p>
<p><code> </code><code>configureCellBlock:(TableViewCellConfigureBlock)aConfigureCellBlock</code></p>
<p><code>    </code><code>cellHeightBlock:(CellHeightBlock)aHeightBlock</code></p>
<p><code>     </code><code>didSelectBlock:(DidSelectCellBlock)didselectBlock ;</code></p>
<p><code>//2</code></p>
<p><code>- (void)handleTableViewDatasourceAndDelegate:(UITableView *)table ;</code></p>
<p><code>//3</code></p>
<p><code>- (id)itemAtIndexPath:(NSIndexPath *)indexPath ;</code></p>
<p><code>@end</code></p>
</td>
</tr>
</tbody>
</table>
<p>注释: <br />
//1. 初始化方法: 传数据源，cellIdentifier, 三个block分别对应配置、行高和点击.</p>
<p>//2. 将UITableViewDataSource和UITableViewDelegate设于XTTableDataDelegate</p>
<p>//3. 默认indexPath.row对应每个dataSource .相应返回item</p>
<p>此外, 为了更彻底, 有必要抽象出"根Cell"。</p>
<table>
<tbody>
<tr>
<td>
<br />
1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12
</td>
<td>
<p><code>#import @interface XTRootCustomCell : UITableViewCell</code></p>
<p> </p>
<p><code>+ (void)registerTable:(UITableView *)table</code></p>
<p><code>        </code><code>nibIdentifier:(NSString *)identifier ; </code><code>// 1</code></p>
<p><code>        </code> </p>
<p><code>- (void)configure:(UITableViewCell *)cell</code></p>
<p><code>        </code><code>customObj:(id)obj</code></p>
<p><code>        </code><code>indexPath:(NSIndexPath *)indexPath ; </code><code>// 2</code></p>
<p><code>        </code> </p>
<p><code>+ (CGFloat)getCellHeightWithCustomObj:(id)obj</code></p>
<p><code>                            </code><code>indexPath:(NSIndexPath *)indexPath ; </code><code>// 3</code></p>
<p><code>@end</code></p>
</td>
</tr>
</tbody>
</table>
<p>故所有cell必须是XTRootCustomCell的子类, 通过子类重写父类方法来实现新Cell .</p>
<p>注释: <br />
//1 .不解释.</p>
<p>//2. 根据数据源配置并绘制cell 子类务必重写该方法</p>
<p>//3. 根据数据源计算cell的高度 子类可重写该方法, 若不写为默认值44.0</p>
<table>
<tbody>
<tr>
<td>
<br />
1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26
</td>
<td>
<p><code>#pragma mark - Public</code></p>
<p><code>+ (void)registerTable:(UITableView *)table</code></p>
<p><code>        </code><code>nibIdentifier:(NSString *)identifier</code></p>
<p><code>{</code></p>
<p><code>    </code><code>[table registerNib:[self nibWithIdentifier:identifier] forCellReuseIdentifier:identifier] ;</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>#pragma mark --</code></p>
<p><code>#pragma mark - Rewrite these func in SubClass !</code></p>
<p><code>- (void)configure:(UITableViewCell *)cell</code></p>
<p><code>        </code><code>customObj:(id)obj</code></p>
<p><code>        </code><code>indexPath:(NSIndexPath *)indexPath</code></p>
<p><code>{</code></p>
<p><code>    </code><code>// Rewrite this func in SubClass !</code></p>
<p><code>    </code> </p>
<p><code>}</code></p>
<p> </p>
<p><code>+ (CGFloat)getCellHeightWithCustomObj:(id)obj</code></p>
<p><code>                            </code><code>indexPath:(NSIndexPath *)indexPath</code></p>
<p><code>{</code></p>
<p><code>    </code><code>// Rewrite this func in SubClass if necessary</code></p>
<p><code>    </code><code>if</code> <code>(!obj) {</code></p>
<p><code>        </code><code>return</code> <code>0.0f ; </code><code>// if obj is null .</code></p>
<p><code>    </code><code>}</code></p>
<p><code>    </code><code>return</code> <code>44.0f ; </code><code>// default cell height</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>那么新cell类的实现如下: 重写父类两个方法</p>
<table>
<tbody>
<tr>
<td>
<br />
1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17
</td>
<td>
<p><code>- (void)configure:(UITableViewCell *)cell</code></p>
<p><code>        </code><code>customObj:(id)obj</code></p>
<p><code>        </code><code>indexPath:(NSIndexPath *)indexPath</code></p>
<p><code>{</code></p>
<p><code>    </code><code>MyObj *myObj = (MyObj *)obj ;</code></p>
<p><code>    </code><code>MyCell *mycell = (MyCell *)cell ;</code></p>
<p><code>    </code><code>mycell.lbTitle.text = myObj.name ;</code></p>
<p><code>    </code><code>mycell.lbHeight.text = [NSString stringWithFormat:@</code><code>"my Height is : %@"</code><code>, @(myObj.height)] ;</code></p>
<p><code>    </code><code>cell.backgroundColor = indexPath.row % 2 ? [UIColor greenColor] : [UIColor brownColor] ;</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>+ (CGFloat)getCellHeightWithCustomObj:(id)obj</code></p>
<p> </p>
<p><code>                            </code><code>indexPath:(NSIndexPath *)indexPath</code></p>
<p><code>{</code></p>
<p><code>    </code><code>return</code> <code>((MyObj *)obj).height ;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>看下结果, 瘦身后的controller干净的不像实力派, 只剩下了这一个方法 .呵呵呵呵 .</p>
<table>
<tbody>
<tr>
<td>
<br />
1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24
</td>
<td>
<p><code>- (void)setupTableView</code></p>
<p><code>{</code></p>
<p><code>    </code><code>self.table.separatorStyle = 0 ;</code></p>
<p><code>    </code> </p>
<p><code>    </code><code>TableViewCellConfigureBlock configureCell = ^(NSIndexPath *indexPath, MyObj *obj, XTRootCustomCell *cell) {</code></p>
<p><code>        </code><code>[cell configure:cell customObj:obj indexPath:indexPath] ;</code></p>
<p><code>    </code><code>} ;</code></p>
<p><code>    </code> </p>
<p><code>    </code><code>CellHeightBlock heightBlock = ^CGFloat(NSIndexPath *indexPath, id item) {</code></p>
<p><code>        </code><code>return</code> <code>[MyCell getCellHeightWithCustomObj:item indexPath:indexPath] ;</code></p>
<p><code>    </code><code>} ;</code></p>
<p><code>    </code> </p>
<p><code>    </code><code>DidSelectCellBlock selectedBlock = ^(NSIndexPath *indexPath, id item) {</code></p>
<p><code>        </code><code>NSLog(@</code><code>"click row : %@"</code><code>,@(indexPath.row)) ;</code></p>
<p><code>    </code><code>} ;</code></p>
<p><code>    </code> </p>
<p><code>    </code><code>self.tableHander = [[XTTableDataDelegate alloc] initWithItems:self.list</code></p>
<p><code>                                                   </code><code>cellIdentifier:MyCellIdentifier</code></p>
<p><code>                                               </code><code>configureCellBlock:configureCell</code></p>
<p><code>                                                  </code><code>cellHeightBlock:heightBlock</code></p>
<p><code>                                                   </code><code>didSelectBlock:selectedBlock] ;</code></p>
<p><code>                                                   </code> </p>
<p><code>    </code><code>[self.tableHander handleTableViewDatasourceAndDelegate:self.table] ;</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>诸多.m文件太过于冗长,我就不贴到博客了，博客主要是讲思路，思路是王道。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-05 00:19:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Controller不是tableView的垃圾桶的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5oB1nb.html" rel="bookmark">使用UISearchDisplayController</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用UISearchDisplayController 虽然UISearchDisplayController名字中带有controller,可他不是一个UIView相关的controller,因为,切换显示UISearchDisplayController的时候,它并没有在UIWindow中加载(UIWindow一次只能加载一个controller,所以可以证明它不属于controller). 可以看看,他是继承自NSObject,是多个控件组合在一起的一个东西. 以下是使用时的效果图: 源码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkyB6b.html" rel="bookmark">UISearchDisplayController</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				// // FirstViewController.swift // SearchDisplayDemo // // Created by Bruce Lee on 24/12/14. // Copyright (c) 2014 Dynamic Cell. All rights reserved. // import UIKit class FirstViewController: UIViewController, UITableViewDelegate, UITableViewDataSou			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAAVgXM.html" rel="bookmark">iOS中的两种搜索方式UISearchDisplayController和UISearchController</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大熊猫猪·侯佩原创或翻译作品.欢迎转载,转载请注明出处. 如果觉得写的不好请多提意见,如果觉得不错请多多支持点赞.谢谢! hopy ;) 以前iOS的搜索一般都使用UISearchDisplayController来完成,不过自从iOS 8.0开始,该控制器被标记为废弃,我们可以在iOS 8.0之后使用一个新的搜索控制器UISearchController来完成搜索. 本篇博文将介绍以上2种搜索控制器的简单用法,并比较它们的区别.Let't Go! UISearchDisplayControll			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRwJ2p.html" rel="bookmark">Swift教程&lowbar;CoreData实例（三）&lowbar;构建控制层（列表数据加载、删除数据）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Swift教程_CoreData实例(一)_构建storyboard Swift教程_CoreData实例(二)_构建数据层 Swift教程_CoreData实例(三)_构建控制层(列表数据加载.删除数据) Swift教程_CoreData实例(四)_构建控制层(查询.更新数据) Swift教程_CoreData实例(五)_构建控制层(添加数据) 四.构建控制层 控制层总体结构包括列表的数据加载.数据的新增.删除.更新.这里我们先来搞定列表controller的功能(数据加载.删除),即PKOB			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7YZ3AM.html" rel="bookmark">xcode6&period;4的tableview不显示title，怎么让它显示？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 xcode6.4的tableview不显示title,怎么让它显示? tableview不显示titile那块部分,一开始发现在navigation controller连在一起的tableview里,storyboard看着明明是有的,可是运行模拟器的时候,就是显示不出来. 菜鸟入门学习xcode中,有谁能帮我解答吗? 解决方案 把这个箭头移到 UINavigationController 那里,就看到了 解决方案二: 选中Navigation Controller 把 initia			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEvmxz.html" rel="bookmark">TableView编辑状态下跳转页面的崩溃处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				29down votefavorite 12 I have a viewController with a UITableView, the rows of which I allow to edit (delete) with a swipe - much like in the Mail app. I do it with, among other, this method: - (BOOL)tableView:(UITableView *)tableView canEditRowAtInd			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXwZWWM.html" rel="bookmark">TableView详细解释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				-.建立 UITableView DataTable = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, 320, 420)]; [DataTable setDelegate:self]; [DataTable setDataSource:self]; [self.view addSubview:DataTable]; [DataTable release]; 二.UITableView各Method说明 //Section总数- (NSA			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRgGjz.html" rel="bookmark">iOS开发UI篇&mdash;直接使用UITableView Controller</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.一般过程 1 // 2 // YYViewController.h 3 // UITableView Controller 4 // 5 // Created by 孔医己 on 14-6-2. 6 // Copyright (c) 2014年 itcast. All rights reserved. 7 // 8 9 #import &lt;UIKit/UIKit.h&gt; 10 11 @interface YYViewController : UIViewController 12 13 @en			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxE1QGp.html" rel="bookmark">swift   UIAlertController 添加tableview</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 swift UIAlertController 添加tableview swift UIAlertController 添加tableview 有例子可以学习下吗 解决方案 UIViewController *controller = [[UIViewController alloc]init]; UITableView *alertTableView; CGRect rect; if (array.count &lt; 4) { rect = CGRectMake(0, 0, 272, 1			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1kwdz.html" rel="bookmark" class="title">xpath的数据和节点类型以及XPath中节点匹配的基本方法</a>
					<div>
						XPath数据类型 XPath可分为四种数据类型: 节点集(node-set) 节点集是通过路径匹配返回的符合条件的一组节点的集合.其它类型的数据不能转换为节点集. 布尔值(boolean) 由函数或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaL0Nz.html" rel="bookmark" class="title">心情娃娃诞生记（无聊的娃娃）</a>
					<div>
						五.无聊的娃娃 --天啊!谁能找件有趣的事提提神啊! 1.打开Basic.psd,另存为Bored.psd.选择Face层,设置前景色为绿色,按Alt+Shift+Delete,填充Face层不透明区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boe0Ep.html" rel="bookmark" class="title">提升网站的pv量攻略&excl;</a>
					<div>
						目前很多的站长朋友都在研究百度搜索引擎的机制与原理,如何才能够让自己优化的网站快速的获得好的排名,我们要知道百度要给予一个网站好的权重值或者好的排名,那都不是单单做好某一个方面就行,这个百度是要分析这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKBX7z.html" rel="bookmark" class="title">Session和Cookie的问题</a>
					<div>
						我现在要做个页面作为查询资料用. 页面上有一些查询条件 下面用DataGrid显示数据 当完成查询可以点DataGrid进入详细信息 当我回来的时候我要记住原来输入的查询条件和查询结果 怎么可以实现呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3xRNM.html" rel="bookmark" class="title">启发你的设计灵感 12个水平滚动的网站设计</a>
					<div>
						从前,水平滚动被认为是不好的,但是现在在网页设计中,它被作为一种独特的方法(通常用于展示),而且貌似在大多数情况下,它的确是以一种聪明的方法来实现.水平滚动并不适用于所有情况,但是一旦处理得当,它将让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKNe5z.html" rel="bookmark" class="title">外链应该以引导用户 解决需求为目标</a>
					<div>
						搜索引擎注重用户体验,一方面为广大站长提供优化指南,一方面着手惩罚低质量的站点.内容质量将决定这网站的排名和走势,但大多数Seoer对于内容的了解仅仅只局限于单方面,认为只要自己网站内容做好了就ok; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBBWKb.html" rel="bookmark" class="title">DEV GridView如何显示行号</a>
					<div>
						private void gridView_CustomDrawRowIndicator(object sender, DevExpress.XtraGrid.Views.Grid.RowIndica ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2296p.html" rel="bookmark" class="title">javascript var的重要性</a>
					<div>
						javascript 的 var 作用是声明变量. 一般情况下不写都不会出错,但有些情况如果不写,会有不同的结果. &lt;div id=&quot;a&quot;&gt;&lt;/div&gt; & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balvBPz.html" rel="bookmark" class="title">冒号和他的学生们程序员提高班纪事系列</a>
					<div>
						冒号和他的学生们(连载27)--接口服务 冒号和他的学生们(连载26)--访问控制 冒号和他的学生们(连载25)--软件应变 冒号和他的学生们(连载24)--对象封装 冒号和他的学生们(连载23)-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKYwVp.html" rel="bookmark" class="title">JavaScript中的Math&period;LOG2E属性使用详解</a>
					<div>
						 这将返回基数2的对数e,大约是 1.442. 语法 1 Math.LOG2E 例子: 1 2 3 4 5 6 7 8 9 10 11 &lt;html&gt; &lt;head&gt; &lt;ti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNQ6Ab.html" rel="bookmark" class="title">百度杀毒关闭自保护状态有什么风险</a>
					<div>
						  百度杀毒关闭自保护状态后,百度杀毒的运行可能遭到恶意软件的妨碍,导致系统有面临风险.可以在&quot;设置中心&quot;开启或临时关闭自保护状态.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baljLqz.html" rel="bookmark" class="title">PHP超时处理应用场合及解决方案全面总结</a>
					<div>
						  [ 概述 ] 在PHP开发中工作里非常多使用到超时处理到超时的场合,我说几个场景: 1. 异步获取数据如果某个后端数据源获取不成功则跳过,不影响整个页面展现 2. 为了保证Web服务器不会因为当个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDY5AOb.html" rel="bookmark" class="title">win8系统电脑百度云如何离线下载文件</a>
					<div>
						  具体方法如下: 1.网页搜索百度云,打开百度云; 2.登陆百度云; 3.选择网盘选项; 4.再选择上方的离线下载; 5.在弹出的小窗口选择新建BT任务,再选择本地的BT种子文件就可以了; 6.要是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaPqAz.html" rel="bookmark" class="title">MSN账户如何登录Skype？</a>
					<div>
						  一.若使用的客户端是最新版的Skype,按以下步骤登录: 1.打开Skype,输入邮箱地址,点击&quot;登录&quot;按钮. 2.账户输入密码,点击登录. 二.若使用的客户端是旧版Skype ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42j11M.html" rel="bookmark" class="title">由 Eclipse 基金会接手的 Java EE 正在发生改变</a>
					<div>
						Java EE 的新东家开始对 Java EE 的开发工作和支持进行更改. 自 Java EE 移交给 Eclipse 基金会以来,它的开发工作和管理方式正在开始改变. 一方面,Oracle 正在制作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd3XBM.html" rel="bookmark" class="title">算法 空间坐标-一个空间坐标算法问题，求请教！</a>
					<div>
						问题描述 一个空间坐标算法问题,求请教! 如图,已知矩形长宽,一个正交的十字在矩形内,假设以矩形左下角为坐标原点,根据十字四边的长度Dl,Dr,Db,Df,确定十字形中心点的坐标(黑点). 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWPRLp.html" rel="bookmark" class="title">请教一下 oc 这道题 第三问怎么做 求解题思路</a>
					<div>
						问题描述 请教一下 oc 这道题 第三问怎么做 求解题思路 // 1.// - 使用可变数组管理所有书籍(定义Book类,包含书名和价格)// - 数组可以添加.删除书籍对象// - 可以从数组中 根 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq844kb.html" rel="bookmark" class="title">如何使用C&num;操作WinAPI</a>
					<div>
						Windows API是对Windows操作系统的API函数,在C#中调用Windows API的实质是托管代码对非托管代码的调用. 主要使用的格式就是:   using System.Runtime ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWV9Pp.html" rel="bookmark" class="title">阿里企业云邮箱 报错 526 Authentication failure&lbrack;0&rsqb;</a>
					<div>
						在阿里万网买了域名 wswhr.com ,申请了免费云邮箱.wswhr@wswhr.com. 阿里云邮箱已经支持POP3收信和SMTP发信功能,默认已开启. 如果是用腾讯邮箱(QQ邮箱来测验,需要开启 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQYKOp.html" rel="bookmark" class="title">javascript-用JavaScript实现jQuery的&dollar;&period;getJSON和&dollar;load&lpar;&rpar;的方法</a>
					<div>
						问题描述 用JavaScript实现jQuery的$.getJSON和$load()的方法 用JavaScript实现jQuery的$.getJSON和$load()的方法 解决方案 jquery就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PNRkp.html" rel="bookmark" class="title">iOS设计模式 - 命令模式</a>
					<div>
						前言: 命令对象封装了如何对目标执行指令的信息,因此客户端或调用者不必了解目标的任何细节,却仍可以对他执行任何已有的操作.通过把请求封装成对象,客 户端可 以把它参数化并置入队列或日志中,也能够支持可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7a90z.html" rel="bookmark" class="title">多方位拓展之路：监控平台MongoDB实践</a>
					<div>
						多方位拓展之路:监控平台MongoDB实践 在&quot;监控平台MongoDB实践&quot;上,千寻位置的技术专家肖应军发表了一场关于MongoDB实践演讲,他的演讲内容主要分为四个方面: 1.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmlDNb.html" rel="bookmark" class="title">求象棋的java棋谱</a>
					<div>
						问题描述 各位兄弟好,我想自己写个象棋游戏但是苦于找不到很好的棋谱,哪位高人能帮我!我的邮箱yiran_liulian@163.com谢谢! 解决方案 解决方案二:LZ很有才!@解决方案三:你随便找个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwWq8M.html" rel="bookmark" class="title">如何抓住你网站的流量来源</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在很多时候,经常在听个人站长和淘宝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw1P0M.html" rel="bookmark" class="title">c&plus;&plus; 嵌入式-c&plus;&plus;有没有类似库一样的头文件，可以用于简单的图像处理</a>
					<div>
						问题描述 c++有没有类似库一样的头文件,可以用于简单的图像处理 有没有一些头文件,包含后可以在Visual Studio上进行一些简单的图像处理,比如读取图像的像素,因为目前是在Visual Stu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJVrvp.html" rel="bookmark" class="title">Mfc资源消息的响应机制</a>
					<div>
						Mfc消息的响应机制   Mfc中有很多资源,如图标资源,菜单资源,工具栏资源等等:那么,资源是如何进行消息响应和消息映射的呢? 它们的流程是: 某种资源--对应的ID号--消息映射--响应函数的声明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPknZlM.html" rel="bookmark" class="title">PowerCube：妈妈再也不用担心我插座不够用</a>
					<div>
						  有没有过这样的经历:插座上插上一个大块头适配器之后,旁边的插孔就插不下别的插头了,大型插座不担心没孔插,但费钱不说占用空间也太大.Allocacoc公司的PowerCube插座就是来解决这个问题. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkYE6p.html" rel="bookmark" class="title">宝类产品跨行取现或被暂停 基金公司重振直销阵地</a>
					<div>
						14日,21世纪经济报道独家报道了央行下发&lt;支付机构网络支付业务管理办法&gt;.&lt;手机支付业务发展指导意见&gt;草案,并进行征求意见的消息,引起了业内强烈关注.记者最新从支付宝.财付通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Qx7aM.html" rel="bookmark" class="title">js获取对象、数组的实际长度&comma;元素实际个数的实现代码&lowbar;javascript技巧</a>
					<div>
						js获取对象.数组的实际长度,元素实际个数的实现代码 /*获取对象.数组的长度.元素个数 *@param obj 要计算长度的元素,可以为object.array.string */ function ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEP65z.html" rel="bookmark" class="title">总结python爬虫抓站的实用技巧&lowbar;python</a>
					<div>
						前言 写过的这些脚本有一个共性,都是和web相关的,总要用到获取链接的一些方法,累积不少爬虫抓站的经验,在此总结一下,那么以后做东西也就不用重复劳动了. 1.最基本的抓站 import urllib2 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
